/*
 * very simple demo for a printerclient running with mars_nwe
 * a real printerclient should be made in assembler
 * as a resident program.
 * the simple idea is to open a named pipe at the mars_nwe server
 * and spool all data to the printer.
 */

#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdarg.h>
#include <bios.h>
#include <dos.h>
typedef union REGS REGS;


static int usage(char *progname)
{
  fprintf(stderr, "Usage:\t%s attachfile printer\n", progname);
  return(1);
}

static FILE *fopen_err(char *fn, char *openmode)
{
  FILE *f=fopen(fn, openmode);
  if (NULL == f) {
    fprintf(stderr, "Open error '%s' with mode='%s'\n", fn, openmode);
  }
  return(f);
}

static int open_err(char *fn, int openmode)
{
  int fd=open(fn, openmode);
  if (fd == -1) {
    fprintf(stderr, "Open error '%s' with openmode='%d'\n", fn, openmode);
  }
  return(fd);
}


void beep()
{
  REGS regsin, regsout;
  regsin.x.ax = 0x0200;
  regsin.x.dx = 0x0007; /* bell */
  intdos(&regsin, &regsout);
}


int key_pressed(void)
{
  REGS regsin, regsout;
  regsin.h.ah = 0x01; /* read key-press */
  regsin.h.al = 0x0; /* read key-press */
  int86(0x16, &regsin, &regsout);
  return((regsout.x.flags & 0x40) ? 0 : 1); /* zeroflag != 0 */
}

static int ask_user(char *p, ...)
{
   int key;
   int flag = 0;
   va_list argptr;
   va_start(argptr, p);
   vfprintf(stderr, p, argptr);
   va_end(argptr);
   fprintf(stderr, "\n Bitte mit (J)a od. (N)ein beantworten! ");
   while (1) {
     key = getch();
     if (key == 'J' || key == 'j') {
       fprintf(stderr, "J\n\n");
       flag = 1;
       break;
     }
     if (key == 'N' || key == 'n') {
       fprintf(stderr, "N\n\n");
       flag = 0;
       break;
     }
     beep();
   }
   return(flag);
}

int main(int argc, char *argv[])
{
  if (argc > 1) {
    int fd=open_err(argv[1], O_RDONLY|O_BINARY);
    if (-1 != fd) {
      FILE *fo=(argc>2) ? fopen_err(argv[2], "w+b") : stdout;
      if (NULL != fo) {
        char buf[512];
        int k;
        while (1) {
          if (fd==-1) fd=open_err(argv[1], O_RDONLY|O_BINARY);

          if (fd==-1) break;

          fcntl(fd1,

          if (0 < (k=read(fd, buf, sizeof(buf)))) {
            if (1 != fwrite(buf, k, 1, fo)) {
              fprintf(stderr, "Writerror in %s\n", argv[2]);
            }
          } else {
            if (key_pressed() && ask_user("Abbrechen ?"))
              break;

            sleep(3);
            close(fd);
            fd=-1;
          }
        }
      } else
        return(usage(argv[0]));
      close(fd);
    } else
      return(usage(argv[0]));
  } else return(usage(argv[0]));
  return(0);
}
